#!/usr/bin/perl

# HTTP-Statistiken pro User / Kummuliert
# ---------------------------------------------
#
# Autor   : B. Isenbuegel / bjoern(at)b-i-services.de
# Version : 1.04
# Datum   : 20.11.2010
# Umgebung: Hostsharing Server
# Lizenz  : GPL2
#
# Auslesen des HTTP Logfiles im HS Format mit Ausgabe
# einer Userliste und der Menge an bertragenen Daten.
#
# History:
# --------
#  1.04    dk     -iptables an logfile angefuegt
#  1.03    dk     an neues logfileformat angepasst
#  1.02    dk     fr Nutzung mit tlog.sh angepasst
#  1.01    dk     angepasst an don00
#  1.00    Is     Erste Version
#
#
# Aufruf:
# -------
# month-http-xfer.pl
#
# Beispiel: month-http-xfer.pl
#
# Hinweis:
# ========
#
# Die Variable $httpfile muss dem jeweiligen Verzeichnisses
# angepasst werden.
# ----------------------------------------------

# Erstellen der aktuellen Jahres und Monatsdaten fr Filenamen
($sekunden, $minuten, $stunden, $monatstag, $monat, $jahr, $wochentag,
 $jahrestag, $sommerzeit)= localtime();
$true_year = $jahr+1900;
$true_month = $monat+1;
$true_month = $true_month < 10 ? $true_month = "0".$true_month :
    $true_month;

# Pfad/Datei des aktuellen Traffic Files (mind. XYZ00 anpassen!)
$httpfile =
    "/home/pacs/XYZ00/var/traffic-iptables-".$true_year."-".$true_month.".log";

open (FIN, $httpfile) || die "Fehler! Konnte Log Datei nicht ffnen! Bitte
Parameter prfen.";

@httpLine=qw (Date Paket BookedXFer NormMaxXfer DayXFer DayXFerHttp DayXFerFtp DayXFerMail);

foreach (<FIN>)
{
    @logdata{@httpLine}=split(/;/,$_, scalar @httpLine);

    $user = $logdata{User};
    $xfer = $logdata{DayXFer};
    $xfersum{$user} = $xfersum{$user} + $xfer ;
    $maxXfer{$user} = $logdata{BookedXFer}
}

foreach $i (sort(keys %xfersum))
{
    printf( "%.3f MB",$xfersum{$i}, $maxXfer{$i});
};
close(FIN);
